#include <iostream>
#include "library.hxx"
#include "expression.hxx"
#include "clinicalexpression.hxx"
#include "cqlannotations.hxx"

using namespace std;
using namespace r1;

int
main (int argc, char* argv[])
{
  try
  {
    auto_ptr<Library> libptr = library(argv[1]);
/*** this is for the serialized output
*/
   xml_schema::namespace_infomap map;
   map["t"].schema = "library.xsd";
   library(std::cout, *libptr, map);
    for (parameters::def_iterator i = libptr->parameters()->def().begin(); i != libptr->parameters()->def().end(); ++i)
    {
       cout<<(*i).localId()<<" "<<(*i).name()<<endl;
       if((*i).parameterTypeSpecifier().present())
       {
          cout<<"\nParam type specifier present";
          TypeSpecifier t = ((*i).parameterTypeSpecifier().get());
          for(TypeSpecifier::annotation_iterator ai = t.annotation().begin(); ai != t.annotation().end(); ++ai)
          {
             ;
          }
       }
    }
    cout<<"\nValue Set names:";
    for (valueSets::def_iterator i = libptr->valueSets()->def().begin(); i != libptr->valueSets()->def().end(); ++i)
    {
      cout <<  (*i).name() << endl;
    }

    cout<<"\nStatements:";
    for(statements::def_iterator i = libptr->statements()->def().begin(); i != libptr->statements()->def().end(); ++i)
    {
    	cout<<"\n"<<(*i).name();
    }
  }
  catch (const xml_schema::exception& e)
  {
    cout << "ERRRRR: " <<e <<" ENNNNNNND"<< endl;
    return 1;
  }
  return 0;
}
